from flask import Flask, render_template, request, redirect, url_for
import os
import json
from datetime import datetime
import pytz

from nltk.tokenize import SyllableTokenizer
from nltk import word_tokenize

app = Flask(__name__)
datap = ""


@app.route("/response/")
def wordnet():
    
    with open("database.json", "r") as f: #close automatically
        json_file = f.read()
    database = json.loads(json_file)
    
    if request.args.get("whatever"):
        
        response = None
        clicked_word = request.args.get("whatever")
        SSP = SyllableTokenizer()
    
        
        if clicked_word in database:
            response = database[clicked_word]
            stories = response["stories"]
            a=stories[0]["A"]
            b=stories[0]["B"]
            word1 = SSP.tokenize(a)
            word2 = SSP.tokenize(b)
            remove1 = []
            remove2 = []
            
            print("word1", word1, len(word1), type(word1))
            print("word2", word2, len(word2), type(word2))
            
#             word1 ['screw', 'dri', 'ver']
#             word2 ['dri', 'ver']

            for i in range(len(word1)):
                print(i)
                print(word1[i])
                if word1[i] in word2:
                    remove1.append(word1[i])
                    remove2.append(word1[i])

            print("remove1", remove1)
            print("remove2", remove2)
            for j in remove1:
                word1.remove(j)
            for k in remove1:
                word2.remove(k)
            print("word1", word1)
            print("word2", word2)
#             word2.remove(word1[i])
#             word1.remove(word1[i])
            
            if not len(word1)==0:
                frab1=word1[0]
            else:
                frab1=""
            if not len(word2)==0:
                frab2=word2[-1]
            else:
                frab2=""
            frab = frab1 + frab2
            
            
#             print(os.path.exists(frab + ".json"))
#             if not os.path.exists(frab + ".json"):
#                 with open(frab+".json", "w") as fra:
#                     frab = { 
#                         frab : [frab]
#                     }
#                     json.dump(frab, fra, indent=1)
            
            
        return render_template("response.html", clicked_word = clicked_word, database = database, stories=stories, a=a, b=b, word1=word1, word2=word2, frab=frab)
            
    else:
        return render_template("first.html", database = database)

    

    
@app.route("/game/", methods=['POST', 'GET'])
def game():
    with open("database2.json", "r") as word: #close automatically
        json_file = word.read()
    submitword = json.loads(json_file)
    
    if request.args.get("whatever"):
        
        response = None
        clicked_word = request.args.get("whatever")

        if clicked_word in submitword:
            response = submitword[clicked_word]
#             stories = response["stories"]
        
        print(clicked_word + ".json")
        print(os.path.exists(clicked_word + ".json"))
        if not os.path.exists(clicked_word + ".json"):
            with open(clicked_word+".json", "w") as fra:
                frab = { 
                    clicked_word: [clicked_word, clicked_word]
                }
                json.dump(frab, fra, indent=1)

        with open(clicked_word+".json", "r") as fra:
            json_file = fra.read()
            data2 = json.loads(json_file)
            datap = data2[clicked_word][-1]
            datap2 = data2[clicked_word][-2]
            type(datap)

        if request.method == 'GET':
            return render_template("index2.html", datap=datap, datap2=datap2)

        else:
            spel = request.form.get('spel')

            with open(clicked_word+".json", "r+") as jsonFile:
                data = json.load(jsonFile)
                data[clicked_word].append(spel)

            with open(clicked_word+".json", "w") as jsonFile:
                json.dump(data, jsonFile, indent=1) 

            with open(clicked_word+".json", "r") as f:
                json_file = f.read()
                database = json.loads(json_file)
                response = database[clicked_word]
            return render_template("index3.html", database = database, response = response, datap=datap, data2=data2)
        
    else:
        return render_template("first2.html", submitword = submitword)


@app.route('/submit/', methods =['GET','POST'])  
def register():    
    if request.method == 'GET':
        return render_template("submit.html")
    else:
        d={}
        time=""
        tz_Amsterdam = pytz.timezone('Europe/Amsterdam')
        datetime_Amsterdam = datetime.now(tz_Amsterdam)
        time=datetime_Amsterdam.strftime("%d/%m/%Y %H:%M:%S") + "(Amsterdam time)"
        name = request.form.get('name')
        w1 = request.form.get('w1').lower()
        w2 = request.form.get('w2').lower()
        story = request.form.get('story')
        d['User']=name
        d['A']=w1
        d['B']=w2
        d['story']=story
        d['Time']=time
        
        
        
        SSP = SyllableTokenizer()


        word1 = SSP.tokenize(w1)
        word2 = SSP.tokenize(w2)
        remove1 = []
        remove2 = []

        print("word1", word1, len(word1), type(word1))
        print("word2", word2, len(word2), type(word2))

#             word1 ['screw', 'dri', 'ver']
#             word2 ['dri', 'ver']

        for i in range(len(word1)):
            print(i)
            print(word1[i])
            if word1[i] in word2:
                remove1.append(word1[i])
                remove2.append(word1[i])

        print("remove1", remove1)
        print("remove2", remove2)
        for j in remove1:
            word1.remove(j)
        for k in remove1:
            word2.remove(k)
        print("word1", word1)
        print("word2", word2)
#             word2.remove(word1[i])
#             word1.remove(word1[i])

        if not len(word1)==0:
            frab1=word1[0]
        else:
            frab1=""
        if not len(word2)==0:
            frab2=word2[-1]
        else:
            frab2=""
        frab = frab1 + frab2
            
        
        if not (name and w1 and w2 and story and time) :
            return "Please write everyting"
        else:
            with open("database2.json", "r+") as jsonFile:
                data = json.load(jsonFile)
                if frab not in data:
                    data[frab] = {
                        "stories" : []
                    }
                data[frab]["stories"].append(d)
                #data.update(set)

            with open("database2.json", "w") as jsonFile:
                json.dump(data, jsonFile, indent=2) #shift + tap -> further function appears 
            return redirect(url_for('first'))
                        
    
                                    
@app.route('/', methods =['GET','POST']) 
def first():
    return render_template("index.html")


@app.route('/letter/')  
def letter():
    return render_template("letter.html")
                                    
                                    

if __name__ == "__main__":
    
    app.run(debug=True, port=5006)
    
    